文章标题 SPOJ - DRUIDEOI : Fata7y Ya Warda!(单调栈)

Fata7y Ya Warda!

Druid (AKA Amr Alaa El-Deen) and little EOIers have finished their training and they are playing “Fatta7y ya warda!”. It’s a kids game when everyone holds hands with two other kids forming a circle, and they keep saying “Fatta7y ya warda!” (Flourish, flower!) (moving away from each other, while still holding hands, to form a huge circle), then “2affely ya warda!” (Die, flower!) (moving back as close to each other as possible, while still holding hands, to form a tiny circle, i.e. a point). That’s it!

Anyway the point is…

While Eagle (AKA Mohamed Ahmed) was watching them playing he was wondering, who’s the first person taller than Druid on his left? Similarly, who’s the first person taller than Druid on his right? Help Eagle find the answer for each person not just Druid.

Input

The input starts with an integer T (1 ≤ T ≤ 20), the number of test cases.

Each test case contains two lines. The first line contains a single integer N (1 ≤ N ≤ 105), the number of persons playing the game. The second line contains N integers hi (1 ≤ hi ≤ 109) the height of the i-th person. They are numbered 1 to N starting from Druid.

Output

For each test case print N lines, in the i-th line print 2 numbers, the index of the first person taller than the i-th person on his left, and the index of the first person taller than the i-th person on his right. If no one is taller than the i-th person print -1 -1.

Example

Input:
3
5
172 170 168 171 169
3
172 169 172
1
172
Output:
-1 -1
1 4
2 4
1 1
4 1
-1 -1
1 3
-1 -1
-1 -1

题意:有n个人站成一个圈,然后编号从1~n,然后每个人有一个身高,然后要我们求出第i个人的左手边其第一个比他还高的人的编号,和右手边起第一个比他高的编号,然后如果这个人是最高,就直接输出-1.
分析:用单调栈,用dpl【i】来维护第 i 个人的左边的比他高的人的位置,然后dpr同理,然后由于是站一个圈,所以我们可以将这n个人扩展成3*n个人,然后通过n+1~2*n个人的dpl和dpr来得到答案。
代码:

#include<iostream>
#include<string>
#include<cstdio>
#include<cstring>
#include<vector>
#include<stack>
#include<math.h>
#include<map>
#include<queue> 
#include<algorithm>
using namespace std;
const int inf = 0x3f3f3f3f;
typedef pair<int,int> pii;

int a[100005*3];
int dpl[100005*3],dpr[100005*3];
stack<int>st; 

int main ()
{
    int T,n;
    scanf ("%d",&T);
    while (T--){
        scanf ("%d",&n);
        int M=-1;
        for (int i=1;i<=n;i++){
            scanf ("%d",&a[i]);
            a[n+i]=a[2*n+i]=a[i];
            M=max(M,a[i]);//求最大值 
        }
        dpl[1]=1;
        while (!st.empty())st.pop();
        st.push(1);
        for (int i=2;i<=3*n;i++){
            while (!st.empty()&&a[st.top()]<=a[i])st.pop();
            if (st.empty())dpl[i]=1;//如果栈已经为空 
            else {
                dpl[i]=st.top();
            }
            st.push(i);//进栈 
        }
        for (int i=n+1;i<=2*n;i++){
            if (a[i]==M)dpl[i]=-1;//如果是最高的,那就是-1 
            else if (dpl[i]>n)dpl[i]-=n;//否则判断是否大于n,是的话那就得-n 
        }

//      for (int i=1+n;i<=2*n;i++){
//          printf ("%d ",dpl[i]);
//      }
//      printf ("\n");

        dpr[3*n]=3*n;
        while (!st.empty())st.pop();//类似上面 
        for (int i=3*n-1;i>=1;i--){
            while (!st.empty()&&a[st.top()]<=a[i])st.pop();
            if (st.empty()){
                dpr[i]=3*n;
            }else {
                dpr[i]=st.top();
            }
            st.push(i);
        }
        for (int i=n+1;i<=2*n;i++){
            if (a[i]==M)dpr[i]=-1;
            else if (dpr[i]>2*n)dpr[i]-=2*n;
            else if (dpr[i]>n)dpr[i]-=n;
        }

//      for (int i=1+n;i<=2*n;i++){
//          printf ("%d ",dpr[i]);
//      }
//      printf ("\n");

        for (int i=n+1;i<=2*n;i++){
            printf ("%d %d\n",dpl[i],dpr[i]);//答案 
        }
    }

    return 0;
}
/*
3
5
170 178 168 171 169
*/
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值